; #########################################################################
	.386
	.model flat, stdcall
	option casemap :none   ; case sensitive

; #########################################################################

	include \masm32\include\windows.inc
	include \masm32\include\user32.inc
	include \masm32\include\kernel32.inc
	include  \MASM32\include\masm32.inc
	
	includelib \masm32\lib\user32.lib
	includelib \masm32\lib\kernel32.lib
	includelib \masm32\lib\masm32.lib

	;include macro.inc	
	ThreadRandom PROTO :DWORD
	WndProc PROTO  :DWORD,  :DWORD,  :DWORD,  :DWORD 
	RandomProc PROTO 	
	winmain PROTO 
	

	STHREAD STRUCT
		Htread dd ?
		threadid dd ?
	STHREAD ENDS
	;-------------------------------------- macros ------------------------------------------------
		ZEROLOCALES MACRO dernierelocale:REQ
			mov ecx,ebp
			lea edx,dernierelocale
			sub ecx,edx
			.if ecx != 0
				push edi
				mov edi,edx
				mov al,0
				cld
				rep stosb
				pop edi			
			.endif
		ENDM
		PuPo MACRO M1, M2
			push M2
			pop  M1
		ENDM		
			
	;---------------------------------------------------------------------------------------------			

.data
	Tcompile STHREAD <>
	szClassName db "invisible",0
	ThreadTerminate dd 0
	MiniMum dd 0
	Maximum dd 0
	hWnd dd 0	
	random dd 0
	ZoneMessagesErreurs db 10000 dup (0)
	asciirandom db 20 dup (0)
	espace db " ",0
	CPT dd 0
	szrandom db "random",0

      freq dd 10 dup(0)
.code
start:
	;--------- define the limits ------------------------
	mov MiniMum,0
	mov Maximum,9
	mov CPT,300			;numbers of random to generate
	;---------------------------------------------------------
	randomize:
	invoke winmain	
	;invoke dwtoa,random,addr asciirandom
	;invoke szCatStr,addr ZoneMessagesErreurs	,addr asciirandom 
	;invoke szCatStr,addr ZoneMessagesErreurs	,addr espace

      mov ebx,random
      inc [freq+ebx*4]

	dec CPT
	.if CPT != 0
		jmp randomize
	.endif
	;--------------- view the result -------------------------------
      xor ebx,ebx
      .while ebx < 10
        invoke dwtoa,[freq+ebx*4],addr asciirandom
        invoke szCatStr,addr ZoneMessagesErreurs,addr asciirandom
        invoke szCatStr,addr ZoneMessagesErreurs,addr espace
        inc ebx
      .endw      

	invoke MessageBox,NULL,ADDR ZoneMessagesErreurs,addr szrandom,MB_OK
	invoke ExitProcess,0
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
winmain PROC 
	LOCAL wc   :WNDCLASSEX
	LOCAL msg  :MSG
	LOCAL Hinstance:DWORD
	ZEROLOCALES Hinstance
	
	invoke GetModuleHandle,NULL
	mov Hinstance,eax

	;==================================================
	; create a not visible window
	;==================================================

	mov wc.cbSize,         sizeof WNDCLASSEX
	mov wc.style,          CS_HREDRAW or CS_VREDRAW 
	mov wc.lpfnWndProc,    offset WndProc        
	PuPo wc.hInstance,      Hinstance   
	mov wc.hbrBackground,  COLOR_BTNFACE+1
	mov wc.lpszClassName,  offset szClassName

	invoke RegisterClassEx, ADDR wc
	invoke CreateWindowEx,0,ADDR szClassName,0,0,0,0,0,0,0,0,Hinstance,0
	;-------------- create a thread -------------------------------------------
	invoke CreateThread,NULL,NULL,ThreadRandom,NULL,NULL,addr Tcompile.threadid
	mov Tcompile.Htread,eax
	;pass time
	invoke SetTimer,hWnd,400,1,NULL		;wait one millisecond and put the test to 1
	
	StartLoop:
	invoke GetMessage,ADDR msg,NULL,0,0		;wait for time finished
	.if eax != 0
		.if eax != -1 ;invalid handle
			invoke TranslateMessage, ADDR msg
			invoke DispatchMessage,  ADDR msg
		.endif
		jmp StartLoop
	.endif	
	ret
winmain endp

;################################################################

ThreadRandom PROC Nothing:DWORD 
	mov eax,MiniMum
	@@:
	.if ThreadTerminate != 1			;is time paste ? ,NOT
		.if eax != Maximum 			;loop inside all possibles values of eax
		inc eax				; 
			jmp @B
		.else 
			mov eax,MiniMum
			jmp @B
		.endif
	.endif
	mov random,eax
	invoke SendMessage,hWnd,WM_CLOSE,NULL,NULL	; close the window		
	invoke CloseHandle,Tcompile.Htread		;close the thread
	mov ThreadTerminate,0			; for the next number
	mov Tcompile.Htread,0
	mov Tcompile.threadid,0
	ret
ThreadRandom endp
;----------------------------------------------------------------------
;################################################################
WndProc proc  hwnd:DWORD, wMsg, wParam, lParam
	mov eax,hwnd
	mov hWnd,eax
	.if wMsg == WM_TIMER
		mov ThreadTerminate,1			;stop the thread
		xor eax,eax ; valeur de retour
	.elseif wMsg == WM_CLOSE || wMsg == WM_DESTROY	
		invoke PostQuitMessage,NULL
		mov eax,0			
	.else
		invoke DefWindowProc,hwnd, wMsg, wParam, lParam				
	.endif
	ret
WndProc endp
end start
